# TODO: Currently this builds against the bundled kpathsea library sources in
# the tarball. We should be building against the kpathsea(-devel) packages
# instead. Lots of missing Requires and BuildRequires. Needs building in Mock
# and rpmlint checking. And testing.

%define enable_japanese 1
%define desktop_file_utils_version 0.9
%{!?_texmf_main: %define _texmf_main %{_datadir}/texmf}

Summary:	An X viewer for DVI files
Name:		xdvik
Version:	22.84.13
Release:	1%{?dist}
Url:		http://xdvi.sourceforge.net/
License: 	GPLv2 and BSD and Public Domain and LGPLv2+ and GPLv2+ and LPPL
Group:		Applications/Publishing
Obsoletes: 	tetex-xdvi < 3.0-99
Provides: 	tetex-xdvi = 3.0-99
Obsoletes: 	xdvi
Provides: 	xdvi
Requires:	texlive-dvips
Requires(post): desktop-file-utils >= %{desktop_file_utils_version}

BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: 	t1lib-devel >= 5.0.2
BuildRequires: 	Xaw3d-devel
BuildRequires:	desktop-file-utils >= %{desktop_file_utils_version}
BuildRequires:	autoconf213
%if %{enable_japanese}
BuildRequires:  freetype-devel >= 2.1.10
%endif

Source0:	http://kent.dl.sourceforge.net/sourceforge/xdvi/%{name}-%{version}.tar.gz
# Source30 is http://xdvi.sourceforge.net/xdvi48x48.gif converted to png
Source30:	xdvi48x48.png
%if %{enable_japanese}
Source1003:	vfontmap
%endif

Patch8:		texlive-2007-xprint.patch
Patch15:	texlive-2007-xdvi-keepflag.patch
Patch24: 	texlive-xdvi-maxchar.patch
Patch304:       texlive-source-xdvi-numlock.patch

%if %{enable_japanese}
# From http://sourceforge.jp/projects/xdvi/
Patch1000:	http://globalbase.dl.sourceforge.jp/xdvi/28452/%{name}-%{version}-j1.34.patch.gz
Patch1003:	pxdvik-22.84.13.patch
%endif

# These patches would conflict with Patch1000 and so must be applied after the
# xdvik directory has been copied to pxdvik below
Patch2000:	xdvik-22.84.13-uint32_t-fix.patch

%description
Xdvik, the kpathsea version of xdvi, is a previewer for DVI files
produced e.g. by the TeX or troff typesetting systems.

If you are installing texlive and you use PlainTeX or you are using DVI files,
you will also need to install xdvi which allows you to view DVI files.
Consider installing texlive-dvips (for converting .dvi files to PostScript
format for printing on PostScript printers), and texlive-latex (a higher level
formatting package which provides an easier-to-use interface for TeX).

%prep
%setup -q
# Remove erroneous test for definition of uint32_t
%patch8 -p1 -b .xprint
# Fix for navigation with a spacebar does not keep position (RH bug #168124)
%patch15 -p1 -b .xdvi-keepflag
%patch24 -p1 -b .maxchar
%patch304 -p0

# Allow Xaw3d enabled build of xdvi
sed -i 's|/Xaw/|/Xaw3d/|' texk/xdvik/gui/*.[ch] texk/xdvik/*.[ch]

# Replace htmlview with the preferred xdg-open
for i in texk/xdvik/browser.c texk/xdvik/gui/xm_prefsP.h texk/xdvik/xdvi.1.in ; do
    sed -i 's/htmlview/xdg-open/g' $i
done

%if %{enable_japanese}
# set up Japanese xdvi in its own directory
cp -a texk/xdvik texk/pxdvik

pushd texk/pxdvik
# This is the Japanese xdvi patch
%patch1000 -p3
popd

# This patch is the big hack to allow us to build both the normal and the
# Japanese xdvi
%patch1003 -p0

# XXX Is this really necessary?
mv texk/pxdvik/vfontmap.sample texk/pxdvik/vfontmap.sample.orig
install -p -m 644 %{SOURCE1003} texk/pxdvik/vfontmap.sample

for i in texk/xdvik texk/pxdvik texk ; do
  ( cd ${i} ; autoconf-2.13 -m $RPM_BUILD_DIR/%{name}-%{version}/texk/etc/autoconf )
done
%endif

%patch2000 -p0

%build
%configure --with-system-t1lib --with-xdvi-x-toolkit=xaw3d

%if %{enable_japanese}
# configure pxdvi with more options
pushd texk/pxdvik
sh `grep "# ./con" config.status |sed -e s/^#\ //` --program-prefix=p --with-default-dvips-path=pdvips
popd
%endif

make %{?_smp_mflags}

# Doc files (the full list of changes is in the texk/xdvik/CHANGES file)
rm -rf CHANGES
cp texk/xdvik/CHANGES .
cp texk/xdvik/README.t1* .

%install
rm -rf $RPM_BUILD_ROOT

# make install DESTDIR=$RPM_BUILD_ROOT doesn't work here
%makeinstall \
        texmf=$RPM_BUILD_ROOT%{_texmf_main} \
        texmfmain=$RPM_BUILD_ROOT%{_texmf_main} \
	INSTDIRS="texk/xdvik texk/pxdvik"

# desktop file
cat > xdvi.desktop <<EOF
[Desktop Entry]
Encoding=UTF-8
Name=DVI Viewer
Type=Application
Comment=DVI viewer for TeX DVI files
Icon=xdvi
MiniIcon=mini-doc1.xpm
Exec=%{_bindir}/xdvi
MimeType=application/x-dvi;
NoDisplay=true
EOF

mkdir -p $RPM_BUILD_ROOT%{_datadir}/{applications,pixmaps}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/

install -p  -m644 %{SOURCE30} $RPM_BUILD_ROOT%{_datadir}/pixmaps/
install -p  -m644 %{SOURCE30} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/xdvi.png
desktop-file-install --vendor "fedora" --delete-original  \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category Graphics \
  xdvi.desktop

# Remove uneeded file
rm $RPM_BUILD_ROOT%{_texmf_main}/release-tetex-src.txt

%if %{enable_japanese}
mkdir -p pxdvik/READMEs
pushd texk/pxdvik
for i in CHANGES.xdvik-jp README.xdvik-jp READMEs/* ; do
  iconv -f EUC-JP -t UTF-8 ${i} \
        -o  ../../pxdvik/${i}
done
popd
install -p -m 644 texk/pxdvik/vfontmap.sample.orig pxdvik/vfontmap.sample
%endif

%post
%{_bindir}/texconfig-sys rehash 2> /dev/null || :
%{_bindir}/update-desktop-database %{_datadir}/applications || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%postun
%{_bindir}/texconfig-sys rehash 2> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc README README.t1mapper README.t1fonts CHANGES 
%{_bindir}/oxdvi
%{_bindir}/xdvi
%{_bindir}/xdvizilla
%{_bindir}/xdvi-xaw3d
%{_texmf_main}/xdvi/
%{_mandir}/man1/oxdvi.1*
%{_mandir}/man1/xdvi.1*
%{_mandir}/man1/xdvizilla.1*
%{_datadir}/pixmaps/xdvi48x48.png
%{_datadir}/icons/hicolor/48x48/apps/xdvi.png
%{_datadir}/applications/fedora-xdvi.desktop

%if %{enable_japanese}
%doc pxdvik/
%{_bindir}/opxdvi
%{_bindir}/pxdvi
%{_bindir}/pxdvizilla
%{_bindir}/pxdvi-xaw3d
%{_texmf_main}/pxdvi/
%endif

%changelog
* Sun Jan  6 2008 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 22.84.13-1
- Initial package based on the texlive.spec by Jindrich Novy
- Updated to latest upstream xdvik and Japanese xdvik 
- Reviewed all patches relating to xdvi in texlive.spec and cherry picked
  those that are still needed
- Reworked the patch to allow building of xdvik and pxdvik
